feat(job_specs): 2n-c7gn
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2024 Cisco and/or its affiliates.
2 # Copyright (c) 2024 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_alt" | "1n_spr")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     parse_env_variables || die "Parse of environment variables failed!"
83
84     # Replace all variables in template with those in environment.
85     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
86         die "Topology file create failed!"
87     }
88
89     WORKING_TOPOLOGY="${CSIT_DIR}/topologies/available/vpp_device.yaml"
90     mv topo.yml "${WORKING_TOPOLOGY}" || {
91         die "Topology move failed!"
92     }
93     cat ${WORKING_TOPOLOGY} | grep -v password || {
94         die "Topology read failed!"
95     }
96
97     # Subfunctions to update data that may depend on topology reserved.
98     set_environment_variables || die
99     select_tags || die
100     compose_robot_arguments || die
101
102 }
103
104
105 function activate_virtualenv () {
106
107     # Update virtualenv pip package, delete and create virtualenv directory,
108     # activate the virtualenv, install requirements, set PYTHONPATH.
109
110     # Arguments:
111     # - ${1} - Path to existing directory for creating virtualenv in.
112     #          If missing or empty, ${CSIT_DIR} is used.
113     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
114     # Variables read:
115     # - CSIT_DIR - Path to existing root of local CSIT git repository.
116     # Variables exported:
117     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
118     # Functions called:
119     # - die - Print to stderr and exit.
120
121     set -exuo pipefail
122
123     root_path="${1-$CSIT_DIR}"
124     env_dir="${root_path}/env"
125     req_path=${2-$CSIT_DIR/requirements.txt}
126     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
127     pip3 install virtualenv==20.15.1 || {
128         die "Virtualenv package install failed."
129     }
130     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
131         die "Virtualenv creation for $(which python3) failed."
132     }
133     set +u
134     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
135     set -u
136     pip3 install -r "${req_path}" || {
137         die "Requirements installation failed."
138     }
139     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
140     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
141 }
142
143
144 function archive_tests () {
145
146     # Create .tar.gz of generated/tests for archiving.
147     # To be run after generate_tests, kept separate to offer more flexibility.
148
149     # Directory read:
150     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
151     # File rewriten:
152     # - ${ARCHIVE_DIR}/generated_tests.tar.gz - Archive of generated tests.
153
154     set -exuo pipefail
155
156     pushd "${ARCHIVE_DIR}" || die
157     tar czf "generated_tests.tar.gz" "${GENERATED_DIR}/tests" || true
158     popd || die
159 }
160
161
162 function check_download_dir () {
163
164     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
165     #
166     # Variables read:
167     # - DOWNLOAD_DIR - Path to directory robot takes the build to test from.
168     # Directories read:
169     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
170     # Functions called:
171     # - die - Print to stderr and exit.
172
173     set -exuo pipefail
174
175     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
176         die "No artifacts downloaded!"
177     fi
178 }
179
180
181 function check_prerequisites () {
182
183     # Fail if prerequisites are not met.
184     #
185     # Functions called:
186     # - installed - Check if application is installed/present in system.
187     # - die - Print to stderr and exit.
188
189     set -exuo pipefail
190
191     if ! installed sshpass; then
192         die "Please install sshpass before continue!"
193     fi
194 }
195
196
197 function common_dirs () {
198
199     # Set global variables, create some directories (without touching content).
200
201     # Variables set:
202     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
203     # - CSIT_DIR - Path to existing root of local CSIT git repository.
204     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
205     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
206     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
207     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
208     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
209     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
210     #   The name is chosen to match what ci-management expects.
211     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
212     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
213     # Directories created if not present:
214     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
215     # Functions called:
216     # - die - Print to stderr and exit.
217
218     set -exuo pipefail
219
220     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
221         die "Some error during locating of this source file."
222     }
223     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
224         die "Some error during dirname call."
225     }
226     # Current working directory could be in a different repo, e.g. VPP.
227     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
228     relative_csit_dir=$(git rev-parse --show-toplevel) || {
229         die "Git rev-parse failed."
230     }
231     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
232     popd || die "Popd failed."
233     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
234         die "Readlink failed."
235     }
236     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/resources/job_specs") || {
237         die "Readlink failed."
238     }
239     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
240         die "Readlink failed."
241     }
242     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
243         die "Readlink failed."
244     }
245     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
246         die "Readlink failed."
247     }
248
249     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
250         die "Readlink failed."
251     }
252     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
253     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
254         die "Readlink failed."
255     }
256     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
257     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
258         die "Readlink failed."
259     }
260     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
261 }
262
263
264 function compose_robot_arguments () {
265
266     # This function is called by run_tests function.
267     # The reason is that some jobs (bisect) perform reservation multiple times,
268     # so WORKING_TOPOLOGY can be different each time.
269     #
270     # Variables read:
271     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
272     # - DUT - CSIT test/ subdirectory, set while processing tags.
273     # - TAGS - Array variable holding selected tag boolean expressions.
274     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
275     # - TEST_CODE - The test selection string from environment or argument.
276     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
277     # Variables set:
278     # - ROBOT_ARGS - String holding part of all arguments for robot.
279     # - EXPANDED_TAGS - Array of strings robot arguments compiled from tags.
280
281     set -exuo pipefail
282
283     # No explicit check needed with "set -u".
284     ROBOT_ARGS=("--loglevel" "TRACE")
285     ROBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
286
287     # TODO: The rest does not need to be recomputed on each reservation.
288     #       Refactor TEST_CODE so this part can be called only once.
289     case "${TEST_CODE}" in
290         *"device"*)
291             ROBOT_ARGS+=("--suite" "tests.${DUT}.device")
292             ;;
293         *"perf"* | *"bisect"*)
294             ROBOT_ARGS+=("--suite" "tests.${DUT}.perf")
295             ;;
296         *)
297             die "Unknown specification: ${TEST_CODE}"
298     esac
299
300     EXPANDED_TAGS=()
301     for tag in "${TAGS[@]}"; do
302         if [[ ${tag} == "!"* ]]; then
303             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
304         else
305             if [[ ${SELECTION_MODE} == "--test" ]]; then
306                 EXPANDED_TAGS+=("--test" "${tag}")
307             else
308                 EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
309             fi
310         fi
311     done
312
313     if [[ ${SELECTION_MODE} == "--test" ]]; then
314         EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}")
315     fi
316 }
317
318
319 function deactivate_docker_topology () {
320
321     # Deactivate virtual vpp-device topology by removing containers.
322     #
323     # Variables read:
324     # - NODENESS - Node multiplicity of desired testbed.
325     # - FLAVOR - Node flavor string, usually describing the processor.
326
327     set -exuo pipefail
328
329     case_text="${NODENESS}_${FLAVOR}"
330     case "${case_text}" in
331         "1n_skx" | "1n_alt" | "1n_spr")
332             ssh="ssh root@172.17.0.1 -p 6022"
333             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
334             # The "declare -f" output is long and boring.
335             set +x
336             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
337                 die "Topology cleanup via shim-dcr failed!"
338             }
339             set -x
340             ;;
341         "1n_vbox")
342             enter_mutex || die
343             clean_environment || {
344                 die "Topology cleanup locally failed!"
345             }
346             exit_mutex || die
347             ;;
348         *)
349             die "Unknown specification: ${case_text}!"
350     esac
351 }
352
353
354 function die () {
355
356     # Print the message to standard error end exit with error code specified
357     # by the second argument.
358     #
359     # Hardcoded values:
360     # - The default error message.
361     # Arguments:
362     # - ${1} - The whole error message, be sure to quote. Optional
363     # - ${2} - the code to exit with, default: 1.
364
365     set -x
366     set +eu
367     warn "${1:-Unspecified run-time error occurred!}"
368     exit "${2:-1}"
369 }
370
371
372 function die_on_robot_error () {
373
374     # Source this fragment if you want to abort on any failed test case.
375     #
376     # Variables read:
377     # - ROBOT_EXIT_STATUS - Set by a robot running fragment.
378     # Functions called:
379     # - die - Print to stderr and exit.
380
381     set -exuo pipefail
382
383     if [[ "${ROBOT_EXIT_STATUS}" != "0" ]]; then
384         die "Test failures are present!" "${ROBOT_EXIT_STATUS}"
385     fi
386 }
387
388
389 function generate_tests () {
390
391     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
392     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
393     # The generation is done by executing any *.py executable
394     # within any subdirectory after copying.
395
396     # This is a separate function, because this code is called
397     # both by autogen checker and entries calling run_robot.
398
399     # Directories read:
400     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
401     # Directories replaced:
402     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
403
404     set -exuo pipefail
405
406     rm -rf "${GENERATED_DIR}/tests" || die
407     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
408     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
409     cmd_line+=("-executable" "-name" "*.py")
410     # We sort the directories, so log output can be compared between runs.
411     file_list=$("${cmd_line[@]}" | sort) || die
412
413     for gen in ${file_list}; do
414         directory="$(dirname "${gen}")" || die
415         filename="$(basename "${gen}")" || die
416         pushd "${directory}" || die
417         ./"${filename}" || die
418         popd || die
419     done
420 }
421
422
423 function get_test_code () {
424
425     # Arguments:
426     # - ${1} - Optional, argument of entry script (or empty as unset).
427     #   Test code value to override job name from environment.
428     # Variables read:
429     # - JOB_NAME - String affecting test selection, default if not argument.
430     # Variables set:
431     # - TEST_CODE - The test selection string from environment or argument.
432     # - NODENESS - Node multiplicity of desired testbed.
433     # - FLAVOR - Node flavor string, usually describing the processor.
434
435     set -exuo pipefail
436
437     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
438     if [[ -z "${TEST_CODE}" ]]; then
439         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
440     fi
441
442     case "${TEST_CODE}" in
443         *"1n-vbox")
444             NODENESS="1n"
445             FLAVOR="vbox"
446             ;;
447         *"1n-skx")
448             NODENESS="1n"
449             FLAVOR="skx"
450             ;;
451         *"1n-spr")
452             NODENESS="1n"
453             FLAVOR="spr"
454             ;;
455         *"1n-alt")
456             NODENESS="1n"
457             FLAVOR="alt"
458             ;;
459         *"1n-aws")
460             NODENESS="1n"
461             FLAVOR="aws"
462             ;;
463         *"2n-aws")
464             NODENESS="2n"
465             FLAVOR="aws"
466             ;;
467         *"3n-aws")
468             NODENESS="3n"
469             FLAVOR="aws"
470             ;;
471         *"2n-c7gn")
472             NODENESS="2n"
473             FLAVOR="c7gn"
474             ;;
475         *"3n-c7gn")
476             NODENESS="3n"
477             FLAVOR="c7gn"
478             ;;
479         *"1n-c6in")
480             NODENESS="1n"
481             FLAVOR="c6in"
482             ;;
483         *"2n-c6in")
484             NODENESS="2n"
485             FLAVOR="c6in"
486             ;;
487         *"3n-c6in")
488             NODENESS="3n"
489             FLAVOR="c6in"
490             ;;
491         *"2n-zn2")
492             NODENESS="2n"
493             FLAVOR="zn2"
494             ;;
495         *"2n-clx")
496             NODENESS="2n"
497             FLAVOR="clx"
498             ;;
499         *"2n-icx")
500             NODENESS="2n"
501             FLAVOR="icx"
502             ;;
503         *"2n-spr")
504             NODENESS="2n"
505             FLAVOR="spr"
506             ;;
507         *"3n-icx")
508             NODENESS="3n"
509             FLAVOR="icx"
510             ;;
511         *"3na-spr")
512             NODENESS="3na"
513             FLAVOR="spr"
514             ;;
515         *"3nb-spr")
516             NODENESS="3nb"
517             FLAVOR="spr"
518             ;;
519         *"3n-snr")
520             NODENESS="3n"
521             FLAVOR="snr"
522             ;;
523         *"3n-icxd")
524             NODENESS="3n"
525             FLAVOR="icxd"
526             ;;
527         *"2n-tx2")
528             NODENESS="2n"
529             FLAVOR="tx2"
530             ;;
531         *"3n-tsh")
532             NODENESS="3n"
533             FLAVOR="tsh"
534             ;;
535         *"3n-alt")
536             NODENESS="3n"
537             FLAVOR="alt"
538             ;;
539     esac
540 }
541
542
543 function get_test_tag_string () {
544
545     # Variables read:
546     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
547     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
548     # - TEST_CODE - The test selection string from environment or argument.
549     # Variables set:
550     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
551     #   May be empty, or even not set on event types not adding comment.
552     # - GIT_BISECT_FROM - If bisecttest, the commit hash to bisect from.
553     #   Else not set.
554     # Variables exported optionally:
555     # - GRAPH_NODE_VARIANT - Node variant to test with, set if found in trigger.
556
557     # TODO: ci-management scripts no longer need to perform this.
558
559     set -exuo pipefail
560
561     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
562         case "${TEST_CODE}" in
563             # Order matters, bisect job contains "perf" in its name.
564             *"bisect"*)
565                 trigger="bisecttest"
566                 ;;
567             *"device"*)
568                 trigger="devicetest"
569                 ;;
570             *"perf"*)
571                 trigger="perftest"
572                 ;;
573             *)
574                 die "Unknown specification: ${TEST_CODE}"
575         esac
576         # Ignore lines not containing the trigger word.
577         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
578         # The vpp-csit triggers trail stuff we are not interested in.
579         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
580         # (except relying on \s whitespace, \S non-whitespace and . both).
581         # The last string is concatenated, only the middle part is expanded.
582         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
583         # On parsing error, TEST_TAG_STRING probably stays empty.
584         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
585         if [[ -z "${TEST_TAG_STRING-}" ]]; then
586             # Probably we got a base64 encoded comment.
587             comment="${GERRIT_EVENT_COMMENT_TEXT}"
588             comment=$(base64 --decode <<< "${comment}" || true)
589             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
590             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
591         fi
592         if [[ "${trigger}" == "bisecttest" ]]; then
593             # Intentionally without quotes, so spaces delimit elements.
594             test_tag_array=(${TEST_TAG_STRING}) || die "How could this fail?"
595             # First "argument" of bisecttest is a commit hash.
596             GIT_BISECT_FROM="${test_tag_array[0]}" || {
597                 die "Bisect job requires commit hash."
598             }
599             # Update the tag string (tag expressions only, no commit hash).
600             TEST_TAG_STRING="${test_tag_array[@]:1}" || {
601                 die "Bisect job needs a single test, no default."
602             }
603         fi
604         if [[ -n "${TEST_TAG_STRING-}" ]]; then
605             test_tag_array=(${TEST_TAG_STRING})
606             if [[ "${test_tag_array[0]}" == "icl" ]]; then
607                 export GRAPH_NODE_VARIANT="icl"
608                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
609             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
610                 export GRAPH_NODE_VARIANT="skx"
611                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
612             fi
613         fi
614     fi
615 }
616
617
618 function installed () {
619
620     # Check if the given utility is installed. Fail if not installed.
621     #
622     # Duplicate of common.sh function, as this file is also used standalone.
623     #
624     # Arguments:
625     # - ${1} - Utility to check.
626     # Returns:
627     # - 0 - If command is installed.
628     # - 1 - If command is not installed.
629
630     set -exuo pipefail
631
632     command -v "${1}"
633 }
634
635
636 function move_archives () {
637
638     # Move archive directory to top of workspace, if not already there.
639     #
640     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
641     # but in some jobs CSIT_DIR is not same as WORKSPACE
642     # (e.g. under VPP_DIR). To simplify ci-management settings,
643     # we want to move the data to the top. We do not want simple copy,
644     # as ci-management is eager with recursive search.
645     #
646     # As some scripts may call this function multiple times,
647     # the actual implementation use copying and deletion,
648     # so the workspace gets "union" of contents (except overwrites on conflict).
649     # The consequence is empty ARCHIVE_DIR remaining after this call.
650     #
651     # As the source directory is emptied,
652     # the check for dirs being different is essential.
653     #
654     # Variables read:
655     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
656     #   Can be unset, then it speeds up manual testing.
657     # - ARCHIVE_DIR - Path to directory with content to be moved.
658     # Directories updated:
659     # - ${WORKSPACE}/archives/ - Created if does not exist.
660     #   Content of ${ARCHIVE_DIR}/ is moved.
661     # Functions called:
662     # - die - Print to stderr and exit.
663
664     set -exuo pipefail
665
666     if [[ -n "${WORKSPACE-}" ]]; then
667         target=$(readlink -f "${WORKSPACE}/archives")
668         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
669             mkdir -p "${target}" || die "Archives dir create failed."
670             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
671             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
672         fi
673     fi
674 }
675
676
677 function prepare_topology () {
678
679     # Prepare virtual testbed topology if needed based on flavor.
680
681     # Variables read:
682     # - TEST_CODE - String affecting test selection, usually jenkins job name.
683     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
684     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
685     # Variables set:
686     # - TERRAFORM_MODULE_DIR - Terraform module directory.
687     # Functions called:
688     # - die - Print to stderr and exit.
689     # - terraform_init - Terraform init topology.
690     # - terraform_apply - Terraform apply topology.
691
692     set -exuo pipefail
693
694     case_text="${NODENESS}_${FLAVOR}"
695     case "${case_text}" in
696         "1n_aws" | "2n_aws" | "3n_aws")
697             export TF_VAR_testbed_name="${TEST_CODE}"
698             TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}-c5n"
699             terraform_init || die "Failed to call terraform init."
700             trap "terraform_destroy" ERR EXIT || {
701                 die "Trap attempt failed, please cleanup manually. Aborting!"
702             }
703             terraform_apply || die "Failed to call terraform apply."
704             ;;
705         "2n_c7gn" | "3n_c7gn")
706             export TF_VAR_testbed_name="${TEST_CODE}"
707             TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-c7gn"
708             terraform_init || die "Failed to call terraform init."
709             trap "terraform_destroy" ERR EXIT || {
710                 die "Trap attempt failed, please cleanup manually. Aborting!"
711             }
712             terraform_apply || die "Failed to call terraform apply."
713             ;;
714         "1n_c6in" | "2n_c6in" | "3n_c6in")
715             export TF_VAR_testbed_name="${TEST_CODE}"
716             TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-c6in"
717             terraform_init || die "Failed to call terraform init."
718             trap "terraform_destroy" ERR EXIT || {
719                 die "Trap attempt failed, please cleanup manually. Aborting!"
720             }
721             terraform_apply || die "Failed to call terraform apply."
722             ;;
723     esac
724 }
725
726
727 function reserve_and_cleanup_testbed () {
728
729     # Reserve physical testbed, perform cleanup, register trap to unreserve.
730     # When cleanup fails, remove from topologies and keep retrying
731     # until all topologies are removed.
732     #
733     # Multiple other functions are called from here,
734     # as they set variables that depend on reserved topology data.
735     #
736     # Variables read:
737     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
738     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
739     # - BUILD_TAG - Any string suitable as filename, identifying
740     #   test run executing this function. May be unset.
741     # Variables set:
742     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
743     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
744     # Functions called:
745     # - die - Print to stderr and exit.
746     # - ansible_playbook - Perform an action using ansible, see ansible.sh
747     # Traps registered:
748     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
749
750     set -exuo pipefail
751
752     while true; do
753         for topo in "${TOPOLOGIES[@]}"; do
754             set +e
755             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
756             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
757             python3 "${scrpt}" "${opts[@]}"
758             result="$?"
759             set -e
760             if [[ "${result}" == "0" ]]; then
761                 # Trap unreservation before cleanup check,
762                 # so multiple jobs showing failed cleanup improve chances
763                 # of humans to notice and fix.
764                 WORKING_TOPOLOGY="${topo}"
765                 echo "Reserved: ${WORKING_TOPOLOGY}"
766                 trap "untrap_and_unreserve_testbed" EXIT || {
767                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
768                     untrap_and_unreserve_testbed "${message}" || {
769                         die "Teardown should have died, not failed."
770                     }
771                     die "Trap attempt failed, unreserve succeeded. Aborting."
772                 }
773                 # Cleanup + calibration checks
774                 set +e
775                 ansible_playbook "cleanup, calibration"
776                 result="$?"
777                 set -e
778                 if [[ "${result}" == "0" ]]; then
779                     break
780                 fi
781                 warn "Testbed cleanup failed: ${topo}"
782                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
783             fi
784             # Else testbed is accessible but currently reserved, moving on.
785         done
786
787         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
788             # Exit the infinite while loop if we made a reservation.
789             warn "Reservation and cleanup successful."
790             break
791         fi
792
793         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
794             die "Run out of operational testbeds!"
795         fi
796
797         # Wait ~3minutes before next try.
798         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
799             die "Sleep time calculation failed."
800         }
801         echo "Sleeping ${sleep_time}"
802         sleep "${sleep_time}" || die "Sleep failed."
803     done
804
805     # Subfunctions to update data that may depend on topology reserved.
806     set_environment_variables || die
807     select_tags || die
808     compose_robot_arguments || die
809 }
810
811
812 function run_robot () {
813
814     # Run robot with options based on input variables.
815     #
816     # Testbed has to be reserved already,
817     # as some data may have changed between reservations,
818     # for example excluded NICs.
819     #
820     # Variables read:
821     # - CSIT_DIR - Path to existing root of local CSIT git repository.
822     # - ARCHIVE_DIR - Path to store robot result files in.
823     # - ROBOT_ARGS, EXPANDED_TAGS - See compose_robot_arguments.sh
824     # - GENERATED_DIR - Tests are assumed to be generated under there.
825     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
826     # - DUT - CSIT test/ subdirectory, set while processing tags.
827     # - TAGS - Array variable holding selected tag boolean expressions.
828     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
829     # - TEST_CODE - The test selection string from environment or argument.
830     # Variables set:
831     # - ROBOT_ARGS - String holding part of all arguments for robot.
832     # - EXPANDED_TAGS - Array of string robot arguments compiled from tags.
833     # - ROBOT_EXIT_STATUS - Exit status of most recent robot invocation.
834     # Functions called:
835     # - die - Print to stderr and exit.
836
837     set -exuo pipefail
838
839     all_options=("--outputdir" "${ARCHIVE_DIR}" "${ROBOT_ARGS[@]}")
840     all_options+=("${EXPANDED_TAGS[@]}")
841
842     pushd "${CSIT_DIR}" || die "Change directory operation failed."
843     set +e
844     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
845     ROBOT_EXIT_STATUS="$?"
846     set -e
847
848     popd || die "Change directory operation failed."
849 }
850
851
852 function select_arch_os () {
853
854     # Set variables affected by local CPU architecture and operating system.
855     #
856     # Variables set:
857     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
858     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
859     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
860
861     set -exuo pipefail
862
863     source /etc/os-release || die "Get OS release failed."
864
865     case "${ID}" in
866         "ubuntu"*)
867             case "${VERSION}" in
868                 *"LTS (Jammy Jellyfish)"*)
869                     IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU_JAMMY"
870                     VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_JAMMY"
871                     PKG_SUFFIX="deb"
872                     ;;
873                 *)
874                     die "Unsupported Ubuntu version!"
875                     ;;
876             esac
877             ;;
878         *)
879             die "Unsupported distro or OS!"
880             ;;
881     esac
882
883     arch=$(uname -m) || {
884         die "Get CPU architecture failed."
885     }
886
887     case "${arch}" in
888         "aarch64")
889             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
890             ;;
891         *)
892             ;;
893     esac
894 }
895
896
897 function select_tags () {
898
899     # Only to be called from the reservation function,
900     # as resulting tags may change based on topology data.
901     #
902     # Variables read:
903     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
904     # - TEST_CODE - String affecting test selection, usually jenkins job name.
905     # - DUT - CSIT test/ subdirectory, set while processing tags.
906     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
907     #   Can be unset.
908     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
909     # - BASH_FUNCTION_DIR - Directory with input files to process.
910     # Variables set:
911     # - TAGS - Array of processed tag boolean expressions.
912     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
913
914     set -exuo pipefail
915
916     # NIC SELECTION
917     case "${TEST_CODE}" in
918         *"1n-aws"* | *"1n-c6in"*)
919             start_pattern='^  SUT:'
920             ;;
921         *)
922             start_pattern='^  TG:'
923             ;;
924     esac
925     end_pattern='^ \? \?[A-Za-z0-9]\+:'
926     # Remove the sections from topology file
927     sed_command="/${start_pattern}/,/${end_pattern}/d"
928     # All topologies NICs
929     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
930                 | grep -hoP "model: \K.*" | sort -u)
931     # Selected topology NICs
932     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
933                | grep -hoP "model: \K.*" | sort -u)
934     # All topologies NICs - Selected topology NICs
935     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
936         die "Computation of excluded NICs failed."
937     }
938
939     # Select default NIC tag.
940     case "${TEST_CODE}" in
941         *"3n-snr")
942             default_nic="nic_intel-e822cq"
943             ;;
944         *"3n-icxd")
945             default_nic="nic_intel-e823c"
946             ;;
947         *"3n-tsh")
948             default_nic="nic_intel-x520-da2"
949             ;;
950         *"3n-icx" | *"2n-icx")
951             default_nic="nic_intel-e810cq"
952             ;;
953         *"3na-spr")
954             default_nic="nic_mellanox-cx7veat"
955             ;;
956         *"3nb-spr")
957             default_nic="nic_intel-e810cq"
958             ;;
959         *"2n-spr")
960             default_nic="nic_intel-e810cq"
961             ;;
962         *"2n-clx" | *"2n-zn2")
963             default_nic="nic_intel-xxv710"
964             ;;
965         *"2n-tx2" | *"3n-alt")
966             default_nic="nic_intel-xl710"
967             ;;
968         *"1n-aws" | *"2n-aws" | *"3n-aws")
969             default_nic="nic_amazon-nitro-50g"
970             ;;
971         *"2n-c7gn" | *"3n-c7gn")
972             default_nic="nic_amazon-nitro-100g"
973             ;;
974         *"1n-c6in" | *"2n-c6in" | *"3n-c6in")
975             default_nic="nic_amazon-nitro-200g"
976             ;;
977         *)
978             default_nic="nic_intel-x710"
979             ;;
980     esac
981
982     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
983     awk_nics_sub_cmd=""
984     awk_nics_sub_cmd+='gsub("xxv710","25ge2p1xxv710");'
985     awk_nics_sub_cmd+='gsub("x710","10ge2p1x710");'
986     awk_nics_sub_cmd+='gsub("xl710","40ge2p1xl710");'
987     awk_nics_sub_cmd+='gsub("x520-da2","10ge2p1x520");'
988     awk_nics_sub_cmd+='gsub("cx556a","100ge2p1cx556a");'
989     awk_nics_sub_cmd+='gsub("2p1cx7veat","200ge2p1cx7veat");'
990     awk_nics_sub_cmd+='gsub("6p3cx7veat","200ge6p3cx7veat");'
991     awk_nics_sub_cmd+='gsub("cx6dx","100ge2p1cx6dx");'
992     awk_nics_sub_cmd+='gsub("e810cq","100ge2p1e810cq");'
993     awk_nics_sub_cmd+='gsub("e822cq","25ge2p1e822cq");'
994     awk_nics_sub_cmd+='gsub("e823c","25ge2p1e823c");'
995     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
996     awk_nics_sub_cmd+='gsub("vic1385","40ge2p1vic1385");'
997     awk_nics_sub_cmd+='gsub("nitro-50g","50ge1p1ENA");'
998     awk_nics_sub_cmd+='gsub("nitro-100g","100ge1p1ENA");'
999     awk_nics_sub_cmd+='gsub("nitro-200g","200ge1p1ENA");'
1000     awk_nics_sub_cmd+='gsub("virtual","1ge1p82540em");'
1001     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
1002     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
1003     awk_nics_sub_cmd+='else if ($9 =="drv_mlx5_core") drv ="mlx5-";'
1004     awk_nics_sub_cmd+='else if ($9 =="drv_af_xdp") drv ="af-xdp-";'
1005     awk_nics_sub_cmd+='else drv="";'
1006     awk_nics_sub_cmd+='if ($1 =="-") cores="";'
1007     awk_nics_sub_cmd+='else cores=$1;'
1008     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-" cores "-" drv $11"-"$5'
1009
1010     # Tag file directory shorthand.
1011     tfd="${JOB_SPECS_DIR}"
1012     case "${TEST_CODE}" in
1013         # Select specific performance tests based on jenkins job type variable.
1014         *"device"* )
1015             readarray -t test_tag_array <<< $(grep -v "#" \
1016                 ${tfd}/vpp_device/${DUT}-${NODENESS}-${FLAVOR}.md |
1017                 awk {"$awk_nics_sub_cmd"} || echo "devicetest") || die
1018             SELECTION_MODE="--test"
1019             ;;
1020         *"hoststack-daily"* )
1021             readarray -t test_tag_array <<< $(grep -v "#" \
1022                 ${tfd}/hoststack_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
1023                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1024             SELECTION_MODE="--test"
1025             ;;
1026         *"ndrpdr-weekly"* )
1027             readarray -t test_tag_array <<< $(grep -v "#" \
1028                 ${tfd}/ndrpdr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
1029                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1030             SELECTION_MODE="--test"
1031             ;;
1032         *"mrr-daily"* )
1033             readarray -t test_tag_array <<< $(grep -v "#" \
1034                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
1035                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1036             SELECTION_MODE="--test"
1037             ;;
1038         *"mrr-weekly"* )
1039             readarray -t test_tag_array <<< $(grep -v "#" \
1040                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
1041                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1042             SELECTION_MODE="--test"
1043             ;;
1044         *"report-iterative"* )
1045             test_sets=(${TEST_TAG_STRING//:/ })
1046             # Run only one test set per run
1047             report_file=${test_sets[0]}.md
1048             readarray -t test_tag_array <<< $(grep -v "#" \
1049                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
1050                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1051             SELECTION_MODE="--test"
1052             ;;
1053         *"report-coverage"* )
1054             test_sets=(${TEST_TAG_STRING//:/ })
1055             # Run only one test set per run
1056             report_file=${test_sets[0]}.md
1057             readarray -t test_tag_array <<< $(grep -v "#" \
1058                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
1059                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1060             SELECTION_MODE="--test"
1061             ;;
1062         * )
1063             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1064                 # If nothing is specified, we will run pre-selected tests by
1065                 # following tags.
1066                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDethip4-ip4base"
1067                                 "mrrAND${default_nic}AND1cAND78bANDethip6-ip6base"
1068                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2bdbasemaclrn"
1069                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2xcbase"
1070                                 "!drv_af_xdp" "!drv_avf")
1071             else
1072                 # If trigger contains tags, split them into array.
1073                 test_tag_array=(${TEST_TAG_STRING//:/ })
1074             fi
1075             SELECTION_MODE="--include"
1076             ;;
1077     esac
1078
1079     # Blacklisting certain tags per topology.
1080     #
1081     # Reasons for blacklisting:
1082     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
1083     case "${TEST_CODE}" in
1084         *"1n-vbox")
1085             test_tag_array+=("!avf")
1086             test_tag_array+=("!vhost")
1087             test_tag_array+=("!flow")
1088             ;;
1089         *"1n-alt")
1090             test_tag_array+=("!flow")
1091             ;;
1092         *"2n-clx")
1093             test_tag_array+=("!ipsechw")
1094             ;;
1095         *"2n-icx")
1096             test_tag_array+=("!ipsechw")
1097             ;;
1098         *"2n-spr")
1099             ;;
1100         *"2n-tx2")
1101             test_tag_array+=("!ipsechw")
1102             ;;
1103         *"2n-zn2")
1104             test_tag_array+=("!ipsechw")
1105             ;;
1106         *"3n-alt")
1107             test_tag_array+=("!ipsechw")
1108             ;;
1109         *"3n-icx")
1110             test_tag_array+=("!ipsechw")
1111             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
1112             ;;
1113         *"3n-snr")
1114             ;;
1115         *"3n-icxd")
1116             ;;
1117         *"3na-spr")
1118             ;;
1119         *"3nb-spr")
1120             ;;
1121         *"3n-tsh")
1122             test_tag_array+=("!drv_avf")
1123             test_tag_array+=("!ipsechw")
1124             ;;
1125         *"1n-aws" | *"2n-aws" | *"3n-aws")
1126             test_tag_array+=("!ipsechw")
1127             ;;
1128         *"2n-c7gn" | *"3n-c7gn")
1129             test_tag_array+=("!ipsechw")
1130             ;;
1131         *"1n-c6in" | *"2n-c6in" | *"3n-c6in")
1132             test_tag_array+=("!ipsechw")
1133             ;;
1134     esac
1135
1136     # We will add excluded NICs.
1137     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
1138
1139     TAGS=()
1140     prefix=""
1141     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1142         if [[ "${TEST_CODE}" != *"device"* ]]; then
1143             # Automatic prefixing for VPP perf jobs to limit the NIC used.
1144             if [[ "${TEST_TAG_STRING-}" != *"nic_"* ]]; then
1145                 prefix="${default_nic}AND"
1146             fi
1147         fi
1148     fi
1149     set +x
1150     for tag in "${test_tag_array[@]}"; do
1151         if [[ "${tag}" == "!"* ]]; then
1152             # Exclude tags are not prefixed.
1153             TAGS+=("${tag}")
1154         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
1155             # Badly formed tag expressions can trigger way too much tests.
1156             set -x
1157             warn "The following tag expression hints at bad trigger: ${tag}"
1158             warn "Possible cause: Multiple triggers in a single comment."
1159             die "Aborting to avoid triggering too many tests."
1160         elif [[ "${tag}" == *"OR"* ]]; then
1161             # If OR had higher precedence than AND, it would be useful here.
1162             # Some people think it does, thus triggering way too much tests.
1163             set -x
1164             warn "The following tag expression hints at bad trigger: ${tag}"
1165             warn "Operator OR has lower precedence than AND. Use space instead."
1166             die "Aborting to avoid triggering too many tests."
1167         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
1168             # Empty and comment lines are skipped.
1169             # Other lines are normal tags, they are to be prefixed.
1170             TAGS+=("${prefix}${tag}")
1171         fi
1172     done
1173     set -x
1174 }
1175
1176
1177 function select_topology () {
1178
1179     # Variables read:
1180     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
1181     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
1182     # - CSIT_DIR - Path to existing root of local CSIT git repository.
1183     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
1184     # Variables set:
1185     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
1186     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
1187     # Functions called:
1188     # - die - Print to stderr and exit.
1189
1190     set -exuo pipefail
1191
1192     case_text="${NODENESS}_${FLAVOR}"
1193     case "${case_text}" in
1194         "1n_aws")
1195             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*1n-aws*.yaml )
1196             TOPOLOGIES_TAGS="1_node_single_link_topo"
1197             ;;
1198         "1n_c6in")
1199             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*1n-c6in*.yaml )
1200             TOPOLOGIES_TAGS="1_node_single_link_topo"
1201             ;;
1202         "1n_alt" | "1n_spr")
1203             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1204             TOPOLOGIES_TAGS="2_node_single_link_topo"
1205             ;;
1206         "1n_vbox")
1207             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1208             TOPOLOGIES_TAGS="2_node_single_link_topo"
1209             ;;
1210         "2n_aws")
1211             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-aws*.yaml )
1212             TOPOLOGIES_TAGS="2_node_single_link_topo"
1213             ;;
1214         "2n_c7gn")
1215             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-c7gn*.yaml )
1216             TOPOLOGIES_TAGS="2_node_single_link_topo"
1217             ;;
1218         "2n_c6in")
1219             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-c6in*.yaml )
1220             TOPOLOGIES_TAGS="2_node_single_link_topo"
1221             ;;
1222         "2n_clx")
1223             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx_*.yaml )
1224             TOPOLOGIES_TAGS="2_node_*_link_topo"
1225             ;;
1226         "2n_icx")
1227             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_icx_*.yaml )
1228             TOPOLOGIES_TAGS="2_node_*_link_topo"
1229             ;;
1230         "2n_spr")
1231             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_spr_*.yaml )
1232             TOPOLOGIES_TAGS="2_node_*_link_topo"
1233             ;;
1234         "2n_tx2")
1235             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_tx2_*.yaml )
1236             TOPOLOGIES_TAGS="2_node_single_link_topo"
1237             ;;
1238         "2n_zn2")
1239             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2_*.yaml )
1240             TOPOLOGIES_TAGS="2_node_*_link_topo"
1241             ;;
1242         "3n_alt")
1243             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_alt_*.yaml )
1244             TOPOLOGIES_TAGS="3_node_single_link_topo"
1245             ;;
1246         "3n_aws")
1247             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-aws*.yaml )
1248             TOPOLOGIES_TAGS="3_node_single_link_topo"
1249             ;;
1250         "3n_c7gn")
1251             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-c7gn*.yaml )
1252             TOPOLOGIES_TAGS="3_node_single_link_topo"
1253             ;;
1254         "3n_c6in")
1255             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-c6in*.yaml )
1256             TOPOLOGIES_TAGS="3_node_single_link_topo"
1257             ;;
1258         "3n_icx")
1259             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_icx_*.yaml )
1260             # Trailing underscore is needed to distinguish from 3n_icxd.
1261             TOPOLOGIES_TAGS="3_node_*_link_topo"
1262             ;;
1263         "3n_icxd")
1264             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_icxd_*.yaml )
1265             TOPOLOGIES_TAGS="3_node_single_link_topo"
1266             ;;
1267         "3n_snr")
1268             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_snr_*.yaml )
1269             TOPOLOGIES_TAGS="3_node_single_link_topo"
1270             ;;
1271         "3n_tsh")
1272             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh_*.yaml )
1273             TOPOLOGIES_TAGS="3_node_single_link_topo"
1274             ;;
1275         "3na_spr")
1276             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3na_spr_*.yaml )
1277             TOPOLOGIES_TAGS="3_node_*_link_topo"
1278             ;;
1279         "3nb_spr")
1280             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3nb_spr_*.yaml )
1281             TOPOLOGIES_TAGS="3_node_*_link_topo"
1282             ;;
1283         *)
1284             # No falling back to default, that should have been done
1285             # by the function which has set NODENESS and FLAVOR.
1286             die "Unknown specification: ${case_text}"
1287     esac
1288
1289     if [[ -z "${TOPOLOGIES-}" ]]; then
1290         die "No applicable topology found!"
1291     fi
1292 }
1293
1294
1295 function set_environment_variables () {
1296
1297     # Depending on testbed topology, overwrite defaults set in the
1298     # resources/libraries/python/Constants.py file
1299     #
1300     # Only to be called from the reservation function,
1301     # as resulting values may change based on topology data.
1302     #
1303     # Variables read:
1304     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1305     # Variables set:
1306     # See specific cases
1307
1308     set -exuo pipefail
1309
1310     case "${TEST_CODE}" in
1311         *"1n-aws" | *"2n-aws" | *"3n-aws")
1312             export TREX_RX_DESCRIPTORS_COUNT=1024
1313             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1314             export TREX_CORE_COUNT=6
1315             # Settings to prevent duration stretching.
1316             export PERF_TRIAL_STL_DELAY=0.1
1317             ;;
1318         *"2n-c7gn" | *"3n-c7gn")
1319             export TREX_RX_DESCRIPTORS_COUNT=1024
1320             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1321             export TREX_CORE_COUNT=6
1322             # Settings to prevent duration stretching.
1323             export PERF_TRIAL_STL_DELAY=0.1
1324             ;;
1325         *"1n-c6in" | *"2n-c6in" | *"3n-c6in")
1326             export TREX_RX_DESCRIPTORS_COUNT=1024
1327             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1328             export TREX_CORE_COUNT=6
1329             # Settings to prevent duration stretching.
1330             export PERF_TRIAL_STL_DELAY=0.1
1331             ;;
1332         *"2n-zn2")
1333             # Maciek's workaround for Zen2 with lower amount of cores.
1334             export TREX_CORE_COUNT=14
1335     esac
1336 }
1337
1338
1339 function untrap_and_unreserve_testbed () {
1340
1341     # Use this as a trap function to ensure testbed does not remain reserved.
1342     # Perhaps call directly before script exit, to free testbed for other jobs.
1343     # This function is smart enough to avoid multiple unreservations (so safe).
1344     # Topo cleanup is executed (call it best practice), ignoring failures.
1345     #
1346     # Hardcoded values:
1347     # - default message to die with if testbed might remain reserved.
1348     # Arguments:
1349     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1350     # Variables read (by inner function):
1351     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1352     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1353     # Variables set:
1354     # - TERRAFORM_MODULE_DIR - Terraform module directory.
1355     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1356     # Trap unregistered:
1357     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1358     # Functions called:
1359     # - die - Print to stderr and exit.
1360     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1361
1362     set -xo pipefail
1363     set +eu  # We do not want to exit early in a "teardown" function.
1364     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1365     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1366     if [[ -z "${wt-}" ]]; then
1367         set -eu
1368         warn "Testbed looks unreserved already. Trap removal failed before?"
1369     else
1370         ansible_playbook "cleanup" || true
1371         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1372             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1373         }
1374         case "${TEST_CODE}" in
1375             *"1n-aws" | *"2n-aws" | *"3n-aws")
1376                 TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}-c5n"
1377                 terraform_destroy || die "Failed to call terraform destroy."
1378                 ;;
1379             *"2n-c7gn" | *"3n-c7gn")
1380                 TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}"
1381                 terraform_destroy || die "Failed to call terraform destroy."
1382                 ;;
1383             *"1n-c6in" | *"2n-c6in" | *"3n-c6in")
1384                 TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}"
1385                 terraform_destroy || die "Failed to call terraform destroy."
1386                 ;;
1387             *)
1388                 ;;
1389         esac
1390         WORKING_TOPOLOGY=""
1391         set -eu
1392     fi
1393 }
1394
1395
1396 function warn () {
1397
1398     # Print the message to standard error.
1399     #
1400     # Arguments:
1401     # - ${@} - The text of the message.
1402
1403     set -exuo pipefail
1404
1405     echo "$@" >&2
1406 }